
#ifndef USH_REDIR_H
#define USH_REDIR_H

// redirects stdin, stdout, and stderr to valid file descriptors ( new_stdXXX )
// and save back the old ones ( old_stdXXX ),
// return 0 on success, -1 on error
int
modify_std_streams( const int new_stdin, const int new_stdout, const int new_stderr,
                        int *old_stdin, int *old_stdout, int *old_stderr );

int
restore_std_streams( const int old_stdin, const int old_stdout, const int old_stderr );

#endif
