#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include "mstring.h"

char *itoa(int i)
{
    // creates a correct-sized string buffer to contain an integer
    char *rv = calloc( sizeof(char), sizeof(int)*8+1 );

    sprintf(rv, "%d", i);

    return rv;
}

char *strrstr( char *s1, char *s2 )
{
	char *sc1, *sc2, *psc1, *ps1;

	if (*s2 == '\0')
		return((char *)s1);

	ps1 = s1 + strlen(s1);

	while(ps1 != s1) {
		--ps1;
		for (psc1 = ps1, sc2 = s2; ; )
			if (*(psc1++) != *(sc2++))
				break;
			else if (*sc2 == '\0')
				return ((char *)ps1);
	}
	return ((char *)NULL);
}

int stracmp( char *s, char **a )
{
    if( !s || !a )
        return 0;

    int i = 0;
    while ( a[i] != NULL )
    {
        if( strcmp( s, a[i] ) == 0 )
            return 1;
        else
            i++;
    }

    return 0;
}

void strupcase( char *s )
{
    if(!s) return;
    while( *s!='\0' )
    {
        *s = toupper(*s);
        s++;
    }
    return;
}

char *strrep(char *string, char *strToRep, char *strReplacement)
{
    char* loc = strstr(string, strToRep);
    if( loc )
    {
        size_t toRepLen = strlen(strToRep);
        size_t repLen = strlen(strReplacement);
        memmove (loc + repLen , loc + toRepLen, strlen(loc + toRepLen)  +1);
        memmove (loc , strReplacement, strlen(strReplacement));
    }
    return loc;
}
