#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "history.h"

#if 0
main()
{
    history hi = create_history(5);

    historize("hello", hi);

    printf("current position: %d\n",hi->current_position);

    historize("ls -l /home/bin", hi);

    printf("current position: %d\n",hi->current_position);

    print_history(hi);

    free_history(hi);
    return 0;

}
#endif


history create_history ( const int size )
{
    history hi =
        malloc( sizeof(struct history_istance) );

    hi->commands = calloc( sizeof(char*), size );
    hi->size = size;
    hi->current_position = 0;

    return hi;
}

void free_history ( history hi )
{
    int i = hi->size;
    while ( i-- )
    {
        free(hi->commands[i]);
    }
    free ( hi );
    return;
}

void historize( const char *cmd, history hi )
{
    if(!*cmd) return; // do not historize empty commands

    // (over)writes current command in history
    free( hi->commands[ hi->current_position ] );
    hi->commands[ hi->current_position ] = strdup( cmd );

    // modifies current position
    if ((hi->current_position+1) >= hi->size)
        (hi->current_position) = 0;
    else
        (hi->current_position)++;

    return;
}

void print_history ( const history hi )
{
    int j = hi->current_position;
    int i, k = 1;
    for( i = 0; i < hi->size; i++ )
    {
        if(j==(hi->size)) j=0;

        if(hi->commands[j])
            printf("  %d  %s\n", k++, hi->commands[j]);

        j++;
    }
    return;
}

char *read_history_elem ( const unsigned int n, const history hi )
{
    if ( n >= (hi->size) )
        return NULL;

    if ( hi->commands[n] )
        return ( hi->commands[n] );
    else
        return NULL;
}
